/*
 * Copyright (c) 1998-2008 TeamDev Ltd. All Rights Reserved.
 * Use is subject to license terms.
 */
package com.teamdev.xpcom.mozilla.demo.components;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Container;
import java.awt.Cursor;
import java.awt.FlowLayout;
import java.awt.Frame;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.RenderingHints;
import java.awt.event.ActionEvent;
import java.awt.event.KeyEvent;

import javax.swing.AbstractAction;
import javax.swing.BorderFactory;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JComponent;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JRootPane;
import javax.swing.KeyStroke;

@SuppressWarnings("serial")
public class AboutDialog extends JDialog
{
    public AboutDialog(Frame owner, String title, String message, ImageIcon icon)
    {
        super(owner, title, true);
        final JLabel text = new JLabel()
        {
            public void paint(Graphics g)
            {
                ((Graphics2D) g).setRenderingHint(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON);
                super.paint(g);
            }
        };
        AbstractAction closeAction = new AbstractAction("  OK  ")
        {
            public void actionPerformed(ActionEvent e)
            {
                setVisible(false);
            }
        };
        JButton closeButton = new JButton(closeAction);
        closeButton.setCursor(new Cursor(Cursor.HAND_CURSOR));
        final Container contentPane = getContentPane();
        contentPane.setBackground(Color.WHITE);
        contentPane.setLayout(new BorderLayout());

        text.setBorder(BorderFactory.createEmptyBorder(15, 15, 15, 15));
        text.setText(message);
        text.setIcon(icon);
        text.setIconTextGap(15);

        final JPanel buttonsPanel = new JPanel(new FlowLayout(FlowLayout.RIGHT));
        buttonsPanel.setBorder(BorderFactory.createEmptyBorder(7, 7, 7, 7));
        buttonsPanel.setOpaque(false);
        buttonsPanel.add(closeButton);
        contentPane.add(text, BorderLayout.CENTER);
        contentPane.add(buttonsPanel, BorderLayout.SOUTH);

        setResizable(false);
        pack();
        setLocationRelativeTo(null);

        KeyStroke escapeKeyStroke = KeyStroke.getKeyStroke(KeyEvent.VK_ESCAPE, 0, false);
        JRootPane rootPane = getRootPane();
        rootPane.getInputMap(JComponent.WHEN_IN_FOCUSED_WINDOW).put(escapeKeyStroke, "ESCAPE");
        rootPane.getActionMap().put("ESCAPE", closeAction);
    }
}
