/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM
 * d:/Mozilla/mozilla/js/src/xpconnect/idl/nsIXPConnect.idl
 */

package org.mozilla.interfaces;

public interface nsIXPConnect extends nsISupports {

  String NS_IXPCONNECT_IID =
    "{c1d4a482-1beb-4c82-9c0b-d2ab93acc7ef}";

  /***************************************************************************/
  void initClasses(long aJSContext, long aGlobalJSObj);

  nsIXPConnectJSObjectHolder initClassesWithNewWrappedGlobal(long aJSContext, nsISupports aCOMObj, String aIID, long aFlags);

  long INIT_JS_STANDARD_CLASSES = 1L;

  long FLAG_SYSTEM_GLOBAL_OBJECT = 2L;

  /**
    * wrapNative will create a new JSObject or return an existing one.
    *
    * The JSObject is returned inside a refcounted nsIXPConnectJSObjectHolder.
    * As long as this holder is held the JSObject will be protected from
    * collection by JavaScript's garbage collector. It is a good idea to
    * transfer the JSObject to some equally protected place before releasing
    * the holder (i.e. use JS_SetProperty to make this object a property of
    * some other JSObject).
    *
    * This method now correctly deals with cases where the passed in xpcom
    * object already has an associated JSObject for the cases:
    *  1) The xpcom object has already been wrapped for use in the same scope
    *     as an nsIXPConnectWrappedNative.
    *  2) The xpcom object is in fact a nsIXPConnectWrappedJS and thus already
    *     has an underlying JSObject.
    *  3) The xpcom object implements nsIScriptObjectOwner; i.e. is an idlc
    *     style DOM object for which we can call GetScriptObject to get the
    *     JSObject it uses to represent itself into JavaScript.
    *
    * It *might* be possible to QueryInterface the nsIXPConnectJSObjectHolder
    * returned by the method into a nsIXPConnectWrappedNative or a
    * nsIXPConnectWrappedJS.
    *
    * This method will never wrap the JSObject involved in an
    * XPCNativeWrapper before returning.
    *
    * Returns:
    *    success:
    *       NS_OK
    *    failure:
    *       NS_ERROR_XPC_BAD_CONVERT_NATIVE
    *       NS_ERROR_XPC_CANT_GET_JSOBJECT_OF_DOM_OBJECT
    *       NS_ERROR_FAILURE
    */
  nsIXPConnectJSObjectHolder wrapNative(long aJSContext, long aScope, nsISupports aCOMObj, String aIID);

  /**
    * wrapJS will yield a new or previously existing xpcom interface pointer
    * to represent the JSObject passed in.
    *
    * This method now correctly deals with cases where the passed in JSObject
    * already has an associated xpcom interface for the cases:
    *  1) The JSObject has already been wrapped as a nsIXPConnectWrappedJS.
    *  2) The JSObject is in fact a nsIXPConnectWrappedNative and thus already
    *     has an underlying xpcom object.
    *  3) The JSObject is of a jsclass which supports getting the nsISupports
    *     from the JSObject directly. This is used for idlc style objects
    *     (e.g. DOM objects).
    *
    * It *might* be possible to QueryInterface the resulting interface pointer
    * to nsIXPConnectWrappedJS.
    *
    * Returns:
    *   success:
    *     NS_OK
    *    failure:
    *       NS_ERROR_XPC_BAD_CONVERT_JS
    *       NS_ERROR_FAILURE
    */
  nsISupports wrapJS(long aJSContext, long aJSObj, String aIID);

  /**
    * This only succeeds if the JSObject is a nsIXPConnectWrappedNative.
    * A new wrapper is *never* constructed.
    */
  nsIXPConnectWrappedNative getWrappedNativeOfJSObject(long aJSContext, long aJSObj);

  void setSecurityManagerForJSContext(long aJSContext, nsIXPCSecurityManager aManager, int flags);

  void getSecurityManagerForJSContext(long aJSContext, nsIXPCSecurityManager[] aManager, int[] flags);

  /**
    * The security manager to use when the current JSContext has no security
    * manager.
    */
  void setDefaultSecurityManager(nsIXPCSecurityManager aManager, int flags);

  void getDefaultSecurityManager(nsIXPCSecurityManager[] aManager, int[] flags);

  nsIStackFrame createStackFrameLocation(long aLanguage, String aFilename, String aFunctionName, int aLineNumber, nsIStackFrame aCaller);

  /**
    * XPConnect builds internal objects that parallel, and are one-to-one with,
    * the JSContexts in the JSRuntime. It builds these objects as needed.
    * This method tells XPConnect to resynchronize its representations with the
    * list of JSContexts currently 'alive' in the JSRuntime. This allows it
    * to cleanup any representations of JSContexts that are no longer valid.
    */
  void syncJSContexts();

  nsIStackFrame getCurrentJSStack();

  long getCurrentNativeCallContext();

  nsIException getPendingException();

  void setPendingException(nsIException aPendingException);

  void debugDump(short depth);

  void debugDumpObject(nsISupports aCOMObj, short depth);

  void debugDumpJSStack(boolean showArgs, boolean showLocals, boolean showThisProps);

  void debugDumpEvalInJSStackFrame(long aFrameNumber, String aSourceText);

  /**
    * Set fallback JSContext to use when xpconnect can't find an appropriate
    * context to use to execute JavaScript.
    *
    * NOTE: This method is DEPRECATED. 
    *       Use nsIThreadJSContextStack::safeJSContext instead.
    */
  void setSafeJSContextForCurrentThread(long cx);

  /**
    * wrapJSAggregatedToNative is just like wrapJS except it is used in cases
    * where the JSObject is also aggregated to some native xpcom Object.
    * At present XBL is the only system that might want to do this.
    *
    * XXX write more!
    *
    * Returns:
    *   success:
    *     NS_OK
    *    failure:
    *       NS_ERROR_XPC_BAD_CONVERT_JS
    *       NS_ERROR_FAILURE
    */
  nsISupports wrapJSAggregatedToNative(nsISupports aOuter, long aJSContext, long aJSObj, String aIID);

  /**
    * This only succeeds if the native object is already wrapped by xpconnect.
    * A new wrapper is *never* constructed.
    */
  nsIXPConnectWrappedNative getWrappedNativeOfNativeObject(long aJSContext, long aScope, nsISupports aCOMObj, String aIID);

  nsIXPCFunctionThisTranslator getFunctionThisTranslator(String aIID);

  nsIXPCFunctionThisTranslator setFunctionThisTranslator(String aIID, nsIXPCFunctionThisTranslator aTranslator);

  nsIXPConnectJSObjectHolder reparentWrappedNativeIfFound(long aJSContext, long aScope, long aNewParent, nsISupports aCOMObj);

  void reparentScopeAwareWrappers(long aJSContext, long aOldScope, long aNewScope);

  void clearAllWrappedNativeSecurityPolicies();

  nsIXPConnectJSObjectHolder getWrappedNativePrototype(long aJSContext, long aScope, nsIClassInfo aClassInfo);

  void releaseJSContext(long aJSContext, boolean noGC);

  long variantToJS(long ctx, long scope, nsIVariant value);

  nsIVariant jSToVariant(long ctx, long value);

  /**
     * Preconfigure XPCNativeWrapper automation so that when a scripted
     * caller whose filename starts with filenamePrefix accesses a wrapped
     * native that is not flagged as "system", the wrapped native will be
     * automatically wrapped with an XPCNativeWrapper.
     *
     * @param aFilenamePrefix the UTF-8 filename prefix to match, which
     *                        should end with a slash (/) character
     * @param aWantNativeWrappers whether XPConnect should produce native
     *                            wrappers for scripts whose paths begin
     *                            with this prefix
     */
  void flagSystemFilenamePrefix(String aFilenamePrefix, boolean aWantNativeWrappers);

  /**
     * Restore an old prototype for wrapped natives of type
     * aClassInfo. This should be used only when restoring an old
     * scope into a state close to where it was prior to
     * being reinitialized.
     */
  void restoreWrappedNativePrototype(long aJSContext, long aScope, nsIClassInfo aClassInfo, nsIXPConnectJSObjectHolder aPrototype);

  /**
     * Create a sandbox for evaluating code in isolation using
     * evalInSandboxObject().
     *
     * @param cx A context to use when creating the sandbox object.
     * @param principal The principal (or NULL to use the null principal)
     *                  to use when evaluating code in this sandbox.
     */
  nsIXPConnectJSObjectHolder createSandbox(long cx, nsIPrincipal principal);

  /**
     * Evaluate script in a sandbox, completely isolated from all
     * other running scripts.
     *
     * @param source The source of the script to evaluate.
     * @param cx The context to use when setting up the evaluation of
     *           the script. The actual evaluation will happen on a new
     *           temporary context.
     * @param sandbox The sandbox object to evaluate the script in.
     * @param returnStringOnly The only results to come out of the
     *                         computation (including exceptions) will
     *                         be coerced into strings created in the
     *                         sandbox.
     * @return The result of the evaluation as a jsval. If the caller
     *         intends to use the return value from this call the caller
     *         is responsible for rooting the jsval before making a call
     *         to this method.
     */
  long evalInSandboxObject(String source, long cx, nsIXPConnectJSObjectHolder sandbox, boolean returnStringOnly);

  /**
     * Wrap a jsval in a cross origin wrapper.
     * @param aJSContext A context to use to create objects.
     * @param aParent The parent to create the wrapper with.
     * @param aWrappedObj The object to wrap.
     */
  long getXOWForObject(long aJSContext, long aParent, long aWrappedObj);

  /**
     * Tells updateXOWs to clear the scope of all of the XOWs it finds.
     */
  long XPC_XOW_CLEARSCOPE = 1L;

  /**
     * Performs an operation over all of |object|'s XOWs such as clearing
     * their scopes or updating their concept of the current principal.
     *
     * @param aJSContext A context to use to perform JS operations.
     * @param aObject Which XPCWrappedNative we should find the XOWs for.
     * @param aWay What operation to perform.
     */
  void updateXOWs(long aJSContext, nsIXPConnectWrappedNative aObject, long aWay);

  /**
     * Root JS objects held by aHolder.
     * @param aHolder The object that hold the JS objects that should be rooted.
     * @param aTrace The tracer for aHolder.
     */
  void addJSHolder(long aHolder, long aTracer);

  /**
     * Stop rooting the JS objects held by aHolder.
     * @param aHolder The object that hold the rooted JS objects.
     */
  void removeJSHolder(long aHolder);

  /**
     * Get the JSClass and JSGetObjectOps pointers to use for
     * identifying JSObjects that hold nsIXPConnectWrappedNative
     * pointers in their private date. See IS_WRAPPER_CLASS in
     * xpcprivate.h for details.
     */
  void getXPCWrappedNativeJSClassInfo(long[] clazz, long[] ops1, long[] ops2);

  /**
     * Whether or not XPConnect should report all JS exceptions when returning
     * from JS into C++. False by default, although any value set in the
     * MOZ_REPORT_ALL_JS_EXCEPTIONS environment variable will override the value
     * passed here.
     */
  void setReportAllJSExceptions(boolean reportAllJSExceptions);

}